Unit qsf9e_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, UTQS12_p;

procedure qsf9e(var RINT :Array of Extended; A :Extended; B :Extended;
                FUN :Proc_F3E_A; RO :Extended; FI :Extended; N :Integer;
                EPS :Extended; K :Integer; L1 :Integer; L2 :Integer;
                var IND :Array of Integer; var R :Array of Extended;
                var IERR :Integer);

implementation

procedure qsf9e(var RINT :Array of Extended; A :Extended; B :Extended;
                FUN :Proc_F3E_A; RO :Extended; FI :Extended; N :Integer;
                EPS :Extended; K :Integer; L1 :Integer; L2 :Integer;
                var IND :Array of Integer; var R :Array of Extended;
                var IERR :Integer);
var
I,IL,J,J1,J2,J3,J4,K1,KW :Integer;
ARG,B1,B2,B3,CRH,CS,DL,EC,ES,H,H2,H4,ROH2,ROH4,SN,SRH,V,W,WK :Extended;
Q :Array [0..4] of Extended;
label
_10,_20,_30,_40,_50,_60,_70,_80,_90,_100;
begin
IL := L1 + L2;
IERR := 0;
for I:=1 to N do
 begin
  R[(I-1)+1*N] := 0.e0;
  R[(I-1)+2*N] := 0.e0;
  IND[I-1] := 0;
_10:
 end;
K1 := K;
if ( K <=  0 ) 
 then K1 := 1;
DL := B - A;
WK := 0.e0;
_20:
H := DL/K1;
H2 := H/2.e0;
H4 := H2/2.e0;
ROH2 := RO*H2;
SRH := Sin(ROH2);
CRH := Cos(ROH2);
if ( ROH2 >  0.33e0 ) 
 then goto _30;
ROH4 := RO*H4;
Q[0] := 0.2666666666666667e0;
Q[1] := 0.7111111111111111e0*Cos(ROH4);
Q[2] := 0.1555555555555556e0*CRH;
Q[3] := 0.7111111111111111e0*Sin(ROH4);
Q[4] := 0.1555555555555556e0*SRH;
goto _40;
_30:
B1 := 1.e0/ROH2;
B2 := B1*B1;
B3 := B2*B2;
Q[0] := 4.e0*B2*(B1*(48.e0*B2 - 19.e0)*SRH + 3.e0*(1.e0 -
    16.e0*B2)*CRH);
Q[1] := 32.e0*B2*(B1*(5.e0 - 12.e0*B2)*SRH - (1.e0 - 12.e0*
    B2)*CRH)/3.e0;
Q[2] := B1*((3.e0 - 46.e0*B2 + 96.e0*B3)*SRH + 2.e0*B1*
    (7.e0 - 48.e0*B2)*CRH)/3.e0;
Q[3] := -16.e0*B2*((1.e0 - 3.e0*B2)*SRH + 3.e0*B1*CRH)/3.e0;
Q[4] := B1*(B1*(11.e0 - 24.e0*B2)*SRH - 3.e0*(1.e0 - 8.e0*B2)*
    CRH)/3.e0;
_40:
FUN(A,R,IND);
for J:=1 to K1 do
 begin
  ARG := A + (2.e0*J - 1.e0)*H2;
  SN := Sin(ARG*RO+FI);
  CS := Cos(ARG*RO+FI);
  for I:=1 to N do
   begin
    V := Q[2]*R[(I-1)+0*N];
    W := -Q[4]*R[(I-1)+0*N];
    R[(I-1)+1*N] := R[(I-1)+1*N] + SN*V + CS*W;
    R[(I-1)+2*N] := R[(I-1)+2*N] + CS*V - SN*W;
_50:
   end;
  J2 := 2;
  J3 := 4;
  J4 := -1;
  for J1:=1 to 4 do
   begin
    FUN(ARG + (J1 - 2.e0)*H4,R,IND);
    for I:=1 to N do
     begin
      V := Q[J2-1]*R[(I-1)+0*N];
      W := J4*Q[J3-1]*R[(I-1)+0*N];
      R[(I-1)+1*N] := R[(I-1)+1*N] + SN*V + CS*W;
      R[(I-1)+2*N] := R[(I-1)+2*N] + CS*V - SN*W;
_60:
     end;
    J2 := J1;
    J3 := J1 + 2;
    J4 := 1;
    if ( J1 =  1 ) 
     then J4 := 0;
_70:
   end;
_80:
 end;
KW := 1;
for I:=1 to N do
 begin
  if ( IND[I-1] >  0 ) 
   then goto _90;
  R[(I-1)+1*N] := R[(I-1)+1*N]*H2;
  R[(I-1)+2*N] := R[(I-1)+2*N]*H2;
  ES := Abs(RINT[(I-1)+0*N] - R[(I-1)+1*N])*L1/(1.e0 + Abs(R[(I-1)+2*N]));
  EC := Abs(RINT[(I-1)+(IL-1)*N] - R[(I-1)+2*N])*L2/(1.e0 + Abs(R[(I-1)+2*N]));
  if ( ES <=  EPS ) and (  EC <=  EPS ) 
   then IND[I-1] := Trunc( K1*WK );
  if ( IND[I-1] =  0 ) 
   then KW := 0;
  RINT[(I-1)+0*N] := R[(I-1)+1*N];
  if ( L2 <>  0 ) 
   then RINT[(I-1)+(IL-1)*N] := R[(I-1)+2*N];
  R[(I-1)+1*N] := 0.e0;
  R[(I-1)+2*N] := 0.e0;
_90:
 end;
if ( EPS <=  0.e0 ) or (  KW >  0 ) 
 then goto _100;
K1 := K1 + K1;
WK := 0.5e0;
if ( K1 <=  1048576 ) 
 then goto _20;
IERR := 65;
UTQS12(IERR,11);
_100:
end;

end.
